diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/DoubleCoordinates.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/DoubleCoordinates.java
index 3e7ef40a5..632fd6f9e 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/DoubleCoordinates.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/DoubleCoordinates.java
@@ -35,7 +35,7 @@ public class DoubleCoordinates {
                 throw CommandExceptions.notInWorld().create();
             }
         }
-        return this.x.get(source.getCoordinates(false).x);
+        return this.x.get(source.getCoordinates(false).x());
     }
 
     public double getY(CommandSource source, boolean offsetHeight) throws CommandSyntaxException {
@@ -46,7 +46,7 @@ public class DoubleCoordinates {
                 throw CommandExceptions.notInWorld().create();
             }
         }
-        return this.y.get(source.getCoordinates(offsetHeight).y);
+        return this.y.get(source.getCoordinates(offsetHeight).y());
     }
 
     public double getZ(CommandSource source) throws CommandSyntaxException {
@@ -57,7 +57,7 @@ public class DoubleCoordinates {
                 throw CommandExceptions.notInWorld().create();
             }
         }
-        return this.z.get(source.getCoordinates(false).z);
+        return this.z.get(source.getCoordinates(false).z());
     }
 
     public boolean hasRelativeCoordinates() {
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java
index 7d3a2a559..98e19091f 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java
@@ -5,9 +5,12 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.ArrayList;
 import java.util.Collections;
@@ -29,10 +32,14 @@ public class EntitySelector {
     private final @Nullable String entityId;
     private final @Nullable String playerName;
     private final MinMaxBounds.Doubles distance;
-    private final Function<Vec3, Vec3> position;
-    private final @Nullable AABB aABB;
-
-    public EntitySelector(int maxResults, boolean includesEntities, BiConsumer<Entity, List<? extends Entity>> order, @Nullable Class<? extends Entity> limitToType, boolean typeInverse, boolean currentEntity, Predicate<Entity> predicate, @Nullable String entityId, @Nullable String playerName, MinMaxBounds.Doubles distance, Function<Vec3, Vec3> position, @Nullable AABB aABB) {
+    private final Function<@NotNull Vector3dc, @NotNull Vector3dc> position;
+    private final @Nullable AABBd aabb;
+
+    public EntitySelector(
+        int maxResults, boolean includesEntities, BiConsumer<Entity, List<? extends Entity>> order,
+        @Nullable Class<? extends Entity> limitToType, boolean typeInverse, boolean currentEntity,
+        Predicate<Entity> predicate, @Nullable String entityId, @Nullable String playerName,
+        MinMaxBounds.Doubles distance, @NotNull Function<@NotNull Vector3dc, @NotNull Vector3dc> position, @Nullable AABBdc aabb) {
         this.maxResults = maxResults;
         this.includesEntities = includesEntities;
         this.order = order;
@@ -44,7 +51,7 @@ public class EntitySelector {
         this.playerName = playerName;
         this.distance = distance;
         this.position = position;
-        this.aABB = aABB;
+        this.aabb = aabb == null ? null : new AABBd(aabb);
     }
 
     public List<? extends Entity> get(CommandSource source) throws CommandSyntaxException {
@@ -84,28 +91,28 @@ public class EntitySelector {
             entities = source.getWorld().players;
         }
 
-        Vec3 sourceCoordinates = source.getCoordinates(true); // Should I leave it as true or should I make it false? I don't know
-        Vec3 position;
+        Vector3dc sourceCoordinates = source.getCoordinates(true); // Should I leave it as true or should I make it false? I don't know
+        Vector3dc position;
         if (sourceCoordinates != null) {
             position = this.position.apply(sourceCoordinates);
-            if (this.aABB != null) {
-                this.aABB.minX = this.aABB.minX + position.x;
-                this.aABB.maxX = this.aABB.maxX + position.x;
-                this.aABB.minY = this.aABB.minY + position.y;
-                this.aABB.maxY = this.aABB.maxY + position.y;
-                this.aABB.minZ = this.aABB.minZ + position.z;
-                this.aABB.maxZ = this.aABB.maxZ + position.z;
+            if (this.aabb != null) {
+                this.aabb.minX = this.aabb.minX + position.x();
+                this.aabb.maxX = this.aabb.maxX + position.x();
+                this.aabb.minY = this.aabb.minY + position.y();
+                this.aabb.maxY = this.aabb.maxY + position.y();
+                this.aabb.minZ = this.aabb.minZ + position.z();
+                this.aabb.maxZ = this.aabb.maxZ + position.z();
             }
         } else {
-            position = this.position.apply(Vec3.fromPool(0, 0, 0));
+            position = this.position.apply(new Vector3d());
         }
 
         List<? extends Entity> temp = new ArrayList<>(entities);
         for (Entity entity : entities) {
-            if ((limitToType != null && limitToType.isInstance(entity) == this.typeInverse)
-                || !predicate.test(entity)
-                || !this.distanceContains(entity, position.x, position.y, position.z)
-                || !aABBIntersectsWithAABB(this.aABB, entity.bb)) {
+            if ((this.limitToType != null && this.limitToType.isInstance(entity) == this.typeInverse)
+                || !this.predicate.test(entity)
+                || !this.distanceContains(entity, position.x(), position.y(), position.z())
+                || !aabbIntersectsWithAABB(this.aabb, entity.bb)) {
                 temp.remove(entity);
             }
         }
@@ -117,7 +124,7 @@ public class EntitySelector {
         // Predicate
         List<Entity> listAfterPredicate = new ArrayList<>();
         for (Entity entity : entities) {
-            if (!predicate.test(entity)) continue;
+            if (!this.predicate.test(entity)) continue;
             listAfterPredicate.add(entity);
         }
 
@@ -133,9 +140,9 @@ public class EntitySelector {
         return this.distance.contains(entity.distanceTo(x, y, z));
     }
 
-    private static boolean aABBIntersectsWithAABB(AABB aABB1, AABB aABB2) {
-        if (aABB1 == null) return true;
-        return aABB2 != null && aABB1.intersects(aABB2);
+    private static boolean aabbIntersectsWithAABB(@Nullable AABBdc aabb1, @Nullable AABBdc aabb2) {
+        if (aabb1 == null) return true;
+        return aabb2 != null && aabb1.intersectsAABB((AABBd) aabb2);
     }
 
     public int getMaxResults() {
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorParser.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorParser.java
index 921213051..b991cf341 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorParser.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorParser.java
@@ -11,9 +11,12 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.net.command.util.CommandHelper;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.Collections;
 import java.util.List;
@@ -138,7 +141,7 @@ public class EntitySelectorParser {
         this.suggestions = this::suggestNameOrSelector;
         if (this.reader.canRead() && this.reader.peek() == '@') {
             if (!this.allowSelectors) {
-                throw SELECTORS_NOT_ALLOWED.createWithContext(this.reader);
+                throw this.SELECTORS_NOT_ALLOWED.createWithContext(this.reader);
             }
             this.parseSelector();
         } else {
@@ -183,30 +186,30 @@ public class EntitySelectorParser {
     }
 
     public EntitySelector getSelector() {
-        AABB aABB;
+        AABBdc aabb;
         if (this.deltaX != null || this.deltaY != null || this.deltaZ != null) {
-            aABB = this.createAabb(this.deltaX == null ? 0.0 : this.deltaX, this.deltaY == null ? 0.0 : this.deltaY, this.deltaZ == null ? 0.0 : this.deltaZ);
+            aabb = this.createAABB(this.deltaX == null ? 0.0 : this.deltaX, this.deltaY == null ? 0.0 : this.deltaY, this.deltaZ == null ? 0.0 : this.deltaZ);
         } else if (this.distance.getMax() != null) {
-            double d = (Double) this.distance.getMax();
-            aABB = AABB.fromPool(-d, -d, -d, d + 1.0, d + 1.0, d + 1.0);
+            double d = this.distance.getMax();
+            aabb = new AABBd(-d, -d, -d, d + 1.0, d + 1.0, d + 1.0);
         } else {
-            aABB = null;
+            aabb = null;
         }
-        Function<Vec3, Vec3> position = this.x == null && this.y == null && this.z == null ? vec3 -> vec3 : vec3 -> Vec3.fromPool(this.x == null ? vec3.x : this.x, this.y == null ? vec3.y : this.y, this.z == null ? vec3.z : this.z);
-        return new EntitySelector(this.maxResults, this.includesEntities, this.order, this.limitToType, this.typeInverse, this.currentEntity, this.predicate, this.entityId, this.playerName, this.distance, position, aABB);
+        Function<Vector3dc, Vector3dc> position = this.x == null && this.y == null && this.z == null ? vec3 -> vec3 : vec -> new Vector3d(this.x == null ? vec.x() : this.x, this.y == null ? vec.y() : this.y, this.z == null ? vec.z() : this.z);
+        return new EntitySelector(this.maxResults, this.includesEntities, this.order, this.limitToType, this.typeInverse, this.currentEntity, this.predicate, this.entityId, this.playerName, this.distance, position, aabb);
     }
 
-    private AABB createAabb(double d, double e, double f) {
-        boolean bl = d < 0.0;
-        boolean bl2 = e < 0.0;
-        boolean bl3 = f < 0.0;
-        double g = bl ? d : 0.0;
-        double h = bl2 ? e : 0.0;
-        double i = bl3 ? f : 0.0;
-        double j = (bl ? 0.0 : d) + 1.0;
-        double k = (bl2 ? 0.0 : e) + 1.0;
-        double l = (bl3 ? 0.0 : f) + 1.0;
-        return AABB.fromPool(g, h, i, j, k, l);
+    private @NotNull AABBd createAABB(double deltaX, double deltaY, double deltaZ) {
+        boolean bl = deltaX < 0.0;
+        boolean bl2 = deltaY < 0.0;
+        boolean bl3 = deltaZ < 0.0;
+        double minX = bl ? deltaX : 0.0;
+        double minY = bl2 ? deltaY : 0.0;
+        double minZ = bl3 ? deltaZ : 0.0;
+        double maxX = (bl ? 0.0 : deltaX) + 1.0;
+        double maxY = (bl2 ? 0.0 : deltaY) + 1.0;
+        double maxZ = (bl3 ? 0.0 : deltaZ) + 1.0;
+        return new AABBd(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
     public void addPredicate(Predicate<Entity> predicate) {
@@ -294,7 +297,7 @@ public class EntitySelectorParser {
     private boolean hasGamemodeNotEquals = false;
     private boolean isSorted = false;
     private boolean hasLimit = false;
-    private boolean hasType = false;
+    private final boolean hasType = false;
     private boolean hasNameEquals = false;
     private boolean hasNameNotEquals = false;
     private boolean hasNbt = false;
@@ -380,7 +383,7 @@ public class EntitySelectorParser {
         this.order = order;
     }
 
-    public void setLimitToType(Class<? extends Entity> type) {
+    public void setLimitToType(@Nullable Class<? extends Entity> type) {
         this.limitToType = type;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/IntegerCoordinates.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/IntegerCoordinates.java
index e207a616c..4aaabfd86 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/IntegerCoordinates.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/IntegerCoordinates.java
@@ -51,7 +51,7 @@ public class IntegerCoordinates {
                 throw CommandExceptions.notInWorld().create();
             }
         }
-        return this.x.get((int) Math.floor(source.getCoordinates(true).x));
+        return this.x.get((int) Math.floor(source.getCoordinates(true).x()));
     }
 
     public int getY(CommandSource source, boolean offsetHeight) throws CommandSyntaxException {
@@ -62,7 +62,7 @@ public class IntegerCoordinates {
                 throw CommandExceptions.notInWorld().create();
             }
         }
-        return this.y.get((int) Math.floor(source.getCoordinates(offsetHeight).y));
+        return this.y.get((int) Math.floor(source.getCoordinates(offsetHeight).y()));
     }
 
     public int getZ(CommandSource source) throws CommandSyntaxException {
@@ -73,7 +73,7 @@ public class IntegerCoordinates {
                 throw CommandExceptions.notInWorld().create();
             }
         }
-        return this.z.get((int) Math.floor(source.getCoordinates(true).z));
+        return this.z.get((int) Math.floor(source.getCoordinates(true).z()));
     }
 
     public boolean hasRelativeCoordinate() {
